The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::UdpSocket Class Reference

STK UDP socket server/client class. More...

`#include <UdpSocket.h>`

Inheritance diagram for stk::UdpSocket:

List of all members.

## Public Member Functions
| UdpSocket (int port=2006)
| Default constructor creates a local UDP socket on port 2006 (or the specified port number).
| ~UdpSocket ()
| The class destructor closes the socket instance.
void | setDestination (int port=2006, std::string hostname="localhost")
| Set the address for subsequent outgoing data sent via the writeBuffer() function.
int | writeBuffer (const void *buffer, long bufferSize, int flags=0)
| Send a buffer to the address specified with the setDestination() function. Returns the number of bytes written or -1 if an error occurs.
int | readBuffer (void *buffer, long bufferSize, int flags=0)
| Read an input buffer, up to length bufferSize. Returns the number of bytes read or -1 if an error occurs.
int | writeBufferTo (const void *buffer, long bufferSize, int port, std::string hostname="localhost", int flags=0)
| Write a buffer to the specified socket. Returns the number of bytes written or -1 if an error occurs.
## Protected Member Functions
void | setAddress (struct sockaddr_in *address, int port=2006, std::string hostname="localhost")
| A protected function for use in writing a socket address structure.

## Detailed Description

STK UDP socket server/client class.

This class provides a uniform cross-platform UDP socket server/client interface. Methods are provided for reading or writing data buffers. The constructor creates a UDP socket and binds it to the specified port. Note that only one socket can be bound to a given port on the same machine.

UDP sockets provide unreliable, connection-less service. Messages can be lost, duplicated, or received out of order. That said, data transmission tends to be faster than with TCP connections and datagrams are not potentially combined by the underlying system.

The user is responsible for checking the values returned by the read/write methods. Values less than or equal to zero indicate the occurence of an error.

by Perry R. Cook and Gary P. Scavone, 1995-2012.

## Constructor & Destructor Documentation

stk::UdpSocket::UdpSocket | ( | int | port = `2006` | ) |

Default constructor creates a local UDP socket on port 2006 (or the specified port number).

An StkError will be thrown if a socket error occurs during instantiation.

## Member Function Documentation

void stk::UdpSocket::setDestination | ( | int | port = `2006`,
|  | std::string | hostname = `"localhost"` |
| ) |  |  |

Set the address for subsequent outgoing data sent via the writeBuffer() function.

An StkError will be thrown if the host is unknown.

int stk::UdpSocket::writeBuffer | ( | const void * | buffer,
|  | long | bufferSize,
|  | int | flags = `0` |
| ) |  |  | `[virtual]`

Send a buffer to the address specified with the setDestination() function. Returns the number of bytes written or -1 if an error occurs.

This function will fail if the default address (set with setDestination()) is invalid or has not been specified.

Implements stk::Socket.

void stk::UdpSocket::setAddress | ( | struct sockaddr_in * | address,
|  | int | port = `2006`,
|  | std::string | hostname = `"localhost"` |
| ) |  |  | `[protected]`

A protected function for use in writing a socket address structure.

An StkError will be thrown if the host is unknown.

The documentation for this class was generated from the following file:

- UdpSocket.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.